package StateMLplus.SMExample.patronEstado;
public class SMExample_FSM implements SMExample_transitionInterface {

	 /*Se crea un objeto por cada estado*/
	 final SMExample_InitState Init;
	 final SMExample_IdleState Idle;
	 final SMExample_ProcessingState Processing;
	 final SMExample_ErrorState Error;
	 protected SMExample_State SMActual;

	 /*Se crea objeto de tipo finFSMinterface*/
	 SMExample_finFSMinterface user;

	 /*SE CREA EL CONSTRUCTOR*/

	 public SMExample_FSM(SMExample_finFSMinterface userNot){

	 /*SE INICIALIZAN LOS ESTADOS*/
		 Init = new SMExample_InitState(this);
		 Idle = new SMExample_IdleState(this);
		 Processing = new SMExample_ProcessingState(this);
		 Error = new SMExample_ErrorState(this);

	 /*Se inicializa topRegion y las regiones que tengan historicos*/
		 SMActual = Init;

	/*Se inicializa el objeto que notificar el fin de la maquina de estados*/
		 user = userNot;

	 }

	/*Se crea un tipo de datos enumerado que contendr los estados actuales de cada regin*/
	 public enum region {
		 SM(SMExample_State.estado.Init);

		 public SMExample_State.estado currentState;/*Variable que almacenar el estado actual*/

	 /*Se crea un constructor para inicializar la varible de estado actual, currentState*/
		 region (SMExample_State.estado estadoIni) {
			 currentState = estadoIni;
		 }
	 }

	/*Se crea una instancia del enumerado region, para poder acceder a sus campos*/
	/*Se debe inicializarlo a cualquier valor del enumerado, da igual cual sea*/
	 region estadoActual = region.SM;

	 /*FUNCION QUE DEVOLVER EL ESTADO ACTUAL DE LA MQUINA DE ESTADOS.
	 DEVOLVER UN TIPO DE DATOS ENUMERADO, QUE CONTENDR EL ESTADO ACTUAL DE CADA REGIN*/
	 public region getEstadoActual (){
		 return estadoActual;
	 }

	/*FUNCION QUE SE ENCARGAR DE ACTUALIZAR EL VALOR DEL ENUMERADO QUE CONTIENE LOS ESTADOS ACTUALES*/
	 public void actualizarEstados(){
		 if(SMActual != null)
			 estadoActual.SM.currentState = SMActual.name;
		 else 
			 estadoActual.SM.currentState = null;
	 }

	 /*FUNCION QUE DEVOLVER LOS ESTADOS ACTUALES DE TODAS LAS REGIONES*/
	 public void getEstadosActualesToString(){
				 if(SMActual != null)
					 System.out.println(">>>>>>>>>> Region SM en estado:" +SMActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region SM no activa");
	 }

	/*TRANSICIONES POSIBLES*/
	 public void start()	{
			 if(SMActual == Init){
				 SMActual.start();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion start, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void processData()	{
			 if(SMActual == Idle){
				 SMActual.processData();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion processData, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void dataOK()	{
			 if(SMActual == Processing){
				 SMActual.dataOK();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion dataOK, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void errorInit()	{
			 if(SMActual == Init){
				 SMActual.errorInit();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion errorInit, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void errorIdle()	{
			 if(SMActual == Idle){
				 SMActual.errorIdle();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion errorIdle, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void errorProcessing()	{
			 if(SMActual == Processing){
				 SMActual.errorProcessing();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion errorProcessing, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void restart()	{
			 if(SMActual == Error){
				 SMActual.restart();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion restart, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void check()	{
			 if(SMActual == Idle){
				 SMActual.check();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion check, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }

	/*EL SIGUIENTE METODO SE ENCARGA DE INFORMAR AL SIMULADOR DE LA ENTRADA A
	 UN ESTADO FINAL, POR LO QUE EL SIMULADOR DEBE FINALIZAR*/

	 void notifyEnd( ){
		 System.out.println ("		>>>> Entrada a estado FINAL => FIN DEL SIMULADOR");
		 user.notifyEnd();
	 } 

}
