package StateMLplus.SMExample2.Ts2FOO;
public class SMExample2_FSM implements SMExample2_transitionInterface {

	/*Se utiliza un objeto de la clase fire, para simular el disparo de las transiciones*/
	 SMExample2_fireTransition fire = new SMExample2_fireTransition();


	 /*Se crea un objeto por cada estado*/
	 final SMExample2_InitState Init;
	 final SMExample2_WorkingState Working;
	 final SMExample2_IdleState Idle;
	 final SMExample2_ProcessingState Processing;
	 final SMExample2_ErrorState Error;
	 final SMExample2_FinState Fin;
	 protected SMExample2_State SMActual;
	 protected SMExample2_State workingRegionActual;

	 /*Se crea objeto de tipo finFSMinterface*/
	 SMExample2_finFSMinterface user;

	 /*SE CREA EL CONSTRUCTOR*/

	 public SMExample2_FSM(SMExample2_finFSMinterface userNot){

	 /*SE INICIALIZAN LOS ESTADOS*/
		 Init = new SMExample2_InitState(this);
		 Working = new SMExample2_WorkingState(this);
		 Idle = new SMExample2_IdleState(this);
		 Processing = new SMExample2_ProcessingState(this);
		 Error = new SMExample2_ErrorState(this);
		 Fin = new SMExample2_FinState(this);

	 /*Se inicializa topRegion y las regiones que tengan historicos*/
		 SMActual = Init;

	/*Se inicializa el objeto que notificar el fin de la maquina de estados*/
		 user = userNot;

	 }

	/*Se crea un tipo de datos enumerado que contendr los estados actuales de cada regin*/
	 public enum region {
		 SM(SMExample2_State.estado.Init),
		 workingRegion(null);

		 public SMExample2_State.estado currentState;/*Variable que almacenar el estado actual*/

	 /*Se crea un constructor para inicializar la varible de estado actual, currentState*/
		 region (SMExample2_State.estado estadoIni) {
			 currentState = estadoIni;
		 }
	 }

	/*Se crea una instancia del enumerado region, para poder acceder a sus campos*/
	/*Se debe inicializar a cualquier valor del enumerado, da igual cual sea*/
	 region estadoActual = region.SM;

	 /*FUNCION QUE DEVOLVER EL ESTADO ACTUAL DE LA MQUINA DE ESTADOS.
	 DEVOLVER UN TIPO DE DATOS ENUMERADO, QUE CONTENDR EL ESTADO ACTUAL DE CADA REGIN*/
	 public region getEstadoActual (){
		 return estadoActual;
	 }

	/*FUNCION QUE SE ENCARGAR DE ACTUALIZAR EL VALOR DEL ENUMERADO QUE CONTIENE LOS ESTADOS ACTUALES*/
	 public void actualizarEstados(){
		 if(SMActual != null)
			 estadoActual.SM.currentState = SMActual.name;
		 else 
			 estadoActual.SM.currentState = null;
		 if(workingRegionActual != null)
			 estadoActual.workingRegion.currentState = workingRegionActual.name;
		 else 
			 estadoActual.workingRegion.currentState = null;
	 }

	 /*FUNCION QUE DEVOLVER LOS ESTADOS ACTUALES DE TODAS LAS REGIONES*/
	 public void getEstadosActualesToString(){
				 if(SMActual != null)
					 System.out.println(">>>>>>>>>> Region SM en estado:" +SMActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region SM no activa");
				 if(workingRegionActual != null)
					 System.out.println(">>>>>>>>>> Region workingRegion en estado:" +workingRegionActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region workingRegion no activa");
	 }

	 public void fireTransition(transition t)throws NullPointerException  {
	   try
 	   {//Parte de cdigo que puede provocar excepciones
	 // -------------------------------------
		 switch (t){
	 // -------------------------------------
		 case start:
			 switch (SMActual.getEstado()){
				 case Init : //Se encuentra en el estado Init
				 	SMActual.onExit();
				 	fire.start_fire();
					SMActual = Working;
					SMActual.onEntry();
					SMActual.ejecutar();
					workingRegionActual = Idle;
					workingRegionActual.onEntry();
					workingRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion start, se continua en estado: ");
				 	 getEstadosActualesToString();
			 }
		 break; 

	 // -------------------------------------
		 case errorInit:
			 switch (SMActual.getEstado()){
				 case Init : //Se encuentra en el estado Init
				 	SMActual.onExit();
				 	fire.errorInit_fire();
					SMActual = Error;
					SMActual.onEntry();
					SMActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion errorInit, se continua en estado: ");
				 	 getEstadosActualesToString();
			 }
		 break; 

	 // -------------------------------------
		 case errorWorking:
			 switch (SMActual.getEstado()){
				 case Working : //Se encuentra en el estado Working
				 	workingRegionActual.onExit();
				 	workingRegionActual = null;
				 	SMActual.onExit();
				 	fire.errorWorking_fire();
					SMActual = Error;
					SMActual.onEntry();
					SMActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion errorWorking, se continua en estado: ");
				 	 getEstadosActualesToString();
			 }
		 break; 

	 // -------------------------------------
		 case restart:
			 switch (SMActual.getEstado()){
				 case Error : //Se encuentra en el estado Error
				 	SMActual.onExit();
				 	fire.restart_fire();
					SMActual = Working;
					SMActual.onEntry();
					SMActual.ejecutar();
					workingRegionActual = Idle;
					workingRegionActual.onEntry();
					workingRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion restart, se continua en estado: ");
				 	 getEstadosActualesToString();
			 }
		 break; 

	 // -------------------------------------
		 case finish:
			 switch (SMActual.getEstado()){
				 case Working : //Se encuentra en el estado Working
				 	workingRegionActual.onExit();
				 	workingRegionActual = null;
				 	SMActual.onExit();
				 	fire.finish_fire();
					SMActual = Fin;
					SMActual.onEntry();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion finish, se continua en estado: ");
				 	 getEstadosActualesToString();
			 }
		 break; 

	 // -------------------------------------
		 case check:
			 switch (workingRegionActual.getEstado()){
				 case Idle : //Se encuentra en el estado Idle
				 	workingRegionActual.onExit();
				 	fire.check_fire();
				 	System.out.println("		>>>> Estado actual de workingRegion : Idle");
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion check, se continua en estado: ");
				 	 getEstadosActualesToString();
			 }
		 break; 

	 // -------------------------------------
		 case processData:
			 switch (workingRegionActual.getEstado()){
				 case Idle : //Se encuentra en el estado Idle
				 	workingRegionActual.onExit();
				 	fire.processData_fire();
					workingRegionActual = Processing;
					workingRegionActual.onEntry();
					workingRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion processData, se continua en estado: ");
				 	 getEstadosActualesToString();
			 }
		 break; 

	 // -------------------------------------
		 case dataOK:
			 switch (workingRegionActual.getEstado()){
				 case Processing : //Se encuentra en el estado Processing
				 	workingRegionActual.onExit();
				 	fire.dataOK_fire();
					workingRegionActual = Idle;
					workingRegionActual.onEntry();
					workingRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion dataOK, se continua en estado: ");
				 	 getEstadosActualesToString();
			 }
		 break; 

		 }//Fin switch (t)
	 // -------------------------------------
	   }//Fin try
	 /* Se comprueba si la excepcin lanzada es del tipo NullPointerException */
	catch (NullPointerException exc)
	 {//se capturan excepciones de tipo NullPointerException
		 System.out.println("No se puede realizar la transicin "+t+", al no estar activa la region a la que pertenece");
		 System.out.println("Lanzada excepcin NullPointerException");
	}
	 /* Con el siguiente catch, se debe asegurar que no se escape ninguna excepcin */
	catch (Exception exc)
	 {//se capturan el resto de Excepciones
		 System.out.println("No se puede realizar la transicin "+t);
		 System.out.println("Lanzada excepcin con mensaje:"+ exc.getMessage());
	 }
	}//Fin fireTransition 

	 // -------------------------------------

	 public void notifyEnd( ){
		 System.out.println ("		>>>> Entrada a estado FINAL => FIN DEL SIMULADOR");
		 user.notifyEnd();
	 } 

}//FIN CLASE FSM
