package StateMLplus.SMExample2.patronEstado;
public class SMExample2_FSM implements SMExample2_transitionInterface {

	 /*Se crea un objeto por cada estado*/
	 final SMExample2_InitState Init;
	 final SMExample2_WorkingState Working;
	 final SMExample2_IdleState Idle;
	 final SMExample2_ProcessingState Processing;
	 final SMExample2_ErrorState Error;
	 final SMExample2_FinState Fin;
	 protected SMExample2_State SMActual;
	 protected SMExample2_State workingRegionActual;

	 /*Se crea objeto de tipo finFSMinterface*/
	 SMExample2_finFSMinterface user;

	 /*SE CREA EL CONSTRUCTOR*/

	 public SMExample2_FSM(SMExample2_finFSMinterface userNot){

	 /*SE INICIALIZAN LOS ESTADOS*/
		 Init = new SMExample2_InitState(this);
		 Working = new SMExample2_WorkingState(this);
		 Idle = new SMExample2_IdleState(this);
		 Processing = new SMExample2_ProcessingState(this);
		 Error = new SMExample2_ErrorState(this);
		 Fin = new SMExample2_FinState(this);

	 /*Se inicializa topRegion y las regiones que tengan historicos*/
		 SMActual = Init;

	/*Se inicializa el objeto que notificar el fin de la maquina de estados*/
		 user = userNot;

	 }

	/*Se crea un tipo de datos enumerado que contendr los estados actuales de cada regin*/
	 public enum region {
		 SM(SMExample2_State.estado.Init),
		 workingRegion(null);

		 public SMExample2_State.estado currentState;/*Variable que almacenar el estado actual*/

	 /*Se crea un constructor para inicializar la varible de estado actual, currentState*/
		 region (SMExample2_State.estado estadoIni) {
			 currentState = estadoIni;
		 }
	 }

	/*Se crea una instancia del enumerado region, para poder acceder a sus campos*/
	/*Se debe inicializarlo a cualquier valor del enumerado, da igual cual sea*/
	 region estadoActual = region.SM;

	 /*FUNCION QUE DEVOLVER EL ESTADO ACTUAL DE LA MQUINA DE ESTADOS.
	 DEVOLVER UN TIPO DE DATOS ENUMERADO, QUE CONTENDR EL ESTADO ACTUAL DE CADA REGIN*/
	 public region getEstadoActual (){
		 return estadoActual;
	 }

	/*FUNCION QUE SE ENCARGAR DE ACTUALIZAR EL VALOR DEL ENUMERADO QUE CONTIENE LOS ESTADOS ACTUALES*/
	 public void actualizarEstados(){
		 if(SMActual != null)
			 estadoActual.SM.currentState = SMActual.name;
		 else 
			 estadoActual.SM.currentState = null;
		 if(workingRegionActual != null)
			 estadoActual.workingRegion.currentState = workingRegionActual.name;
		 else 
			 estadoActual.workingRegion.currentState = null;
	 }

	 /*FUNCION QUE DEVOLVER LOS ESTADOS ACTUALES DE TODAS LAS REGIONES*/
	 public void getEstadosActualesToString(){
				 if(SMActual != null)
					 System.out.println(">>>>>>>>>> Region SM en estado:" +SMActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region SM no activa");
				 if(workingRegionActual != null)
					 System.out.println(">>>>>>>>>> Region workingRegion en estado:" +workingRegionActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region workingRegion no activa");
	 }

	/*TRANSICIONES POSIBLES*/
	 public void start()	{
			 if(SMActual == Init){
				 SMActual.start();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion start, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void errorInit()	{
			 if(SMActual == Init){
				 SMActual.errorInit();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion errorInit, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void errorWorking()	{
			 if(SMActual == Working){
				 SMActual.errorWorking();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion errorWorking, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void restart()	{
			 if(SMActual == Error){
				 SMActual.restart();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion restart, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void finish()	{
			 if(SMActual == Working){
				 SMActual.finish();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion finish, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void check()	{
			 if(workingRegionActual == Idle){
				 workingRegionActual.check();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion check, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void processData()	{
			 if(workingRegionActual == Idle){
				 workingRegionActual.processData();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion processData, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }
	 public void dataOK()	{
			 if(workingRegionActual == Processing){
				 workingRegionActual.dataOK();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion dataOK, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
			 }
	 }

	/*EL SIGUIENTE METODO SE ENCARGA DE INFORMAR AL SIMULADOR DE LA ENTRADA A
	 UN ESTADO FINAL, POR LO QUE EL SIMULADOR DEBE FINALIZAR*/

	 void notifyEnd( ){
		 System.out.println ("		>>>> Entrada a estado FINAL => FIN DEL SIMULADOR");
		 user.notifyEnd();
	 } 

}
