package StateMLplus.SMExample3.Ts2FOO;
public class SMExample3_FSM implements SMExample3_transitionInterface {

	/*Se utiliza un objeto de la clase fire, para simular el disparo de las transiciones*/
	 SMExample3_fireTransition fire = new SMExample3_fireTransition();


	 /*Se crea un objeto por cada estado*/
	 final SMExample3_ReadyState Ready;
	 final SMExample3_MovingState Moving;
	 final SMExample3_InitToolState InitTool;
	 final SMExample3_OrientedToolState OrientedTool;
	 final SMExample3_PositionToolState PositionTool;
	 final SMExample3_InitArmState InitArm;
	 final SMExample3_CalculatingPathState CalculatingPath;
	 final SMExample3_MovingArmState MovingArm;
	 final SMExample3_ErrorState Error;
	 final SMExample3_FinishedState Finished;
	 final SMExample3_EmergencyStopState EmergencyStop;
	 final SMExample3_EndState End;
	 protected SMExample3_State topRegionActual;
	 protected SMExample3_State toolRegionActual;
	 protected SMExample3_State armRegionActual;
	 protected SMExample3_State toolRegionHistory;
	 /*Se crea objeto de tipo finFSMinterface*/
	 SMExample3_finFSMinterface user;

	 /*SE CREA EL CONSTRUCTOR*/

	 public SMExample3_FSM(SMExample3_finFSMinterface userNot){

	 /*SE INICIALIZAN LOS ESTADOS*/
		 Ready = new SMExample3_ReadyState(this);
		 Moving = new SMExample3_MovingState(this);
		 InitTool = new SMExample3_InitToolState(this);
		 OrientedTool = new SMExample3_OrientedToolState(this);
		 PositionTool = new SMExample3_PositionToolState(this);
		 InitArm = new SMExample3_InitArmState(this);
		 CalculatingPath = new SMExample3_CalculatingPathState(this);
		 MovingArm = new SMExample3_MovingArmState(this);
		 Error = new SMExample3_ErrorState(this);
		 Finished = new SMExample3_FinishedState(this);
		 EmergencyStop = new SMExample3_EmergencyStopState(this);
		 End = new SMExample3_EndState(this);

	 /*Se inicializa topRegion y las regiones que tengan historicos*/
		 topRegionActual = Ready;
		 toolRegionHistory = InitTool;
	/*Se inicializa el objeto que notificar el fin de la maquina de estados*/
		 user = userNot;

	 }

	/*Se crea un tipo de datos enumerado que contendr los estados actuales de cada regin*/
	 public enum region {
		 topRegion(SMExample3_State.estado.Ready),
		 toolRegion(null),
		 armRegion(null);

		 public SMExample3_State.estado currentState;/*Variable que almacenar el estado actual*/

	 /*Se crea un constructor para inicializar la varible de estado actual, currentState*/
		 region (SMExample3_State.estado estadoIni) {
			 currentState = estadoIni;
		 }
	 }

	/*Se crea una instancia del enumerado region, para poder acceder a sus campos*/
	/*Se debe inicializar a cualquier valor del enumerado, da igual cual sea*/
	 region estadoActual = region.topRegion;

	 /*FUNCION QUE DEVOLVER EL ESTADO ACTUAL DE LA MQUINA DE ESTADOS.
	 DEVOLVER UN TIPO DE DATOS ENUMERADO, QUE CONTENDR EL ESTADO ACTUAL DE CADA REGIN*/
	 public region getEstadoActual (){
		 return estadoActual;
	 }

	/*FUNCION QUE SE ENCARGAR DE ACTUALIZAR EL VALOR DEL ENUMERADO QUE CONTIENE LOS ESTADOS ACTUALES*/
	 public void actualizarEstados(){
		 if(topRegionActual != null)
			 estadoActual.topRegion.currentState = topRegionActual.name;
		 else 
			 estadoActual.topRegion.currentState = null;
		 if(toolRegionActual != null)
			 estadoActual.toolRegion.currentState = toolRegionActual.name;
		 else 
			 estadoActual.toolRegion.currentState = null;
		 if(armRegionActual != null)
			 estadoActual.armRegion.currentState = armRegionActual.name;
		 else 
			 estadoActual.armRegion.currentState = null;
	 }

	 /*FUNCION QUE DEVOLVER LOS ESTADOS ACTUALES DE TODAS LAS REGIONES*/
	 public void getEstadosActualesToString(){
				 if(topRegionActual != null)
					 System.out.println(">>>>>>>>>> Region topRegion en estado:" +topRegionActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region topRegion no activa");
				 if(toolRegionActual != null)
					 System.out.println(">>>>>>>>>> Region toolRegion en estado:" +toolRegionActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region toolRegion no activa");
				 if(armRegionActual != null)
					 System.out.println(">>>>>>>>>> Region armRegion en estado:" +armRegionActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region armRegion no activa");
	 }

	 public void fireTransition(transition t)throws NullPointerException ,transitionErrorException {
	   try
 	   {//Parte de cdigo que puede provocar excepciones
	 // -------------------------------------
		 switch (t){
	 // -------------------------------------
		 case go:
			 switch (topRegionActual.getEstado()){
				 case Ready : //Se encuentra en el estado Ready
				 	topRegionActual.onExit();
				 	fire.go_fire();
					topRegionActual = Moving;
					topRegionActual.onEntry();
					topRegionActual.ejecutar();
					toolRegionActual = toolRegionHistory;
					toolRegionActual.onEntry();
					toolRegionActual.ejecutar();
					armRegionActual = InitArm;
					armRegionActual.onEntry();
					armRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion go, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case contCmd:
			 switch (topRegionActual.getEstado()){
				 case Ready : //Se encuentra en el estado Ready
				 	topRegionActual.onExit();
				 	fire.contCmd_fire();
				 	topRegionActual = Moving;
				 	topRegionActual.onEntry();
				 	topRegionActual.ejecutar();
				 //----------------------------
					toolRegionActual = OrientedTool;
					toolRegionActual.onEntry();
					toolRegionActual.ejecutar();
				 //----------------------------
					armRegionActual = CalculatingPath;
					armRegionActual.onEntry();
					armRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion contCmd, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case error:
			 switch (topRegionActual.getEstado()){
				 case Moving : //Se encuentra en el estado Moving
				 	armRegionActual.onExit();
				 	armRegionActual = null;
				 	toolRegionActual.onExit();
				 	toolRegionHistory = toolRegionActual;
				 	toolRegionActual = null;
				 	topRegionActual.onExit();
				 	fire.error_fire();
					topRegionActual = Error;
					topRegionActual.onEntry();
					topRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion error, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case done:
				 if( (toolRegionActual == PositionTool) && (armRegionActual == MovingArm) ){
				 	toolRegionActual.onExit();
					toolRegionHistory = toolRegionActual;
					toolRegionActual = null;
				 	armRegionActual.onExit();
					armRegionActual = null;
				 	topRegionActual.onExit();
				 	fire.done_fire();
					topRegionActual = Finished;
					topRegionActual.onEntry();
					topRegionActual.ejecutar();
				  }
				 else { 
				 	 System.out.println ("No se puede realizar la transicion done, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
				 }
		 break; 

	 // -------------------------------------
		 case abort:
			 switch (topRegionActual.getEstado()){
				 case Moving : //Se encuentra en el estado Moving
				 	armRegionActual.onExit();
				 	armRegionActual = null;
				 	toolRegionActual.onExit();
				 	toolRegionHistory = toolRegionActual;
				 	toolRegionActual = null;
				 	topRegionActual.onExit();
				 	fire.abort_fire();
					topRegionActual = Ready;
					topRegionActual.onEntry();
					topRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion abort, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case sysRecovered:
			 switch (topRegionActual.getEstado()){
				 case Error : //Se encuentra en el estado Error
				 	topRegionActual.onExit();
				 	fire.sysRecovered_fire();
					topRegionActual = Ready;
					topRegionActual.onEntry();
					topRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion sysRecovered, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case end:
			 switch (topRegionActual.getEstado()){
				 case Finished : //Se encuentra en el estado Finished
				 	topRegionActual.onExit();
				 	fire.end_fire();
					topRegionActual = End;
					topRegionActual.onEntry();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion end, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case reStart:
			 switch (topRegionActual.getEstado()){
				 case EmergencyStop : //Se encuentra en el estado EmergencyStop
				 	topRegionActual.onExit();
				 	fire.reStart_fire();
					topRegionActual = Ready;
					topRegionActual.onEntry();
					topRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion reStart, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case initialized:
			 switch (toolRegionActual.getEstado()){
				 case InitTool : //Se encuentra en el estado InitTool
				 	toolRegionActual.onExit();
				 	fire.initialized_fire();
					toolRegionActual = OrientedTool;
					toolRegionActual.onEntry();
					toolRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion initialized, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case oriented:
			 switch (toolRegionActual.getEstado()){
				 case OrientedTool : //Se encuentra en el estado OrientedTool
				 	toolRegionActual.onExit();
				 	fire.oriented_fire();
					toolRegionActual = PositionTool;
					toolRegionActual.onEntry();
					toolRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion oriented, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case armInitialized:
			 switch (armRegionActual.getEstado()){
				 case InitArm : //Se encuentra en el estado InitArm
				 	armRegionActual.onExit();
				 	fire.armInitialized_fire();
					armRegionActual = CalculatingPath;
					armRegionActual.onEntry();
					armRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion armInitialized, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case calcDone:
			 switch (armRegionActual.getEstado()){
				 case CalculatingPath : //Se encuentra en el estado CalculatingPath
				 	armRegionActual.onExit();
				 	fire.calcDone_fire();
					armRegionActual = MovingArm;
					armRegionActual.onEntry();
					armRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion calcDone, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

	 // -------------------------------------
		 case movementDetect:
			 switch (armRegionActual.getEstado()){
				 case MovingArm : //Se encuentra en el estado MovingArm
				 	armRegionActual.onExit();
				 	fire.movementDetect_fire();
					armRegionActual = null;
					toolRegionActual.onExit();
					toolRegionHistory = toolRegionActual;
					toolRegionActual = null;
					topRegionActual.onExit();
					topRegionActual = EmergencyStop;
					topRegionActual.onEntry();
					topRegionActual.ejecutar();
				 	break; 

				 default:
				 	 System.out.println ("No se puede realizar la transicion movementDetect, se continua en estado: ");
				 	 getEstadosActualesToString();
				 	 throw new transitionErrorException();
			 }
		 break; 

		 }//Fin switch (t)
	 // -------------------------------------
	   }//Fin try

 	 /* Al heredar transitionErrorException de NullPointerException se comprueba
	 si la excepcin lanzada es del tipo transitionErrorException */
	catch (transitionErrorException exc)
	 {//se capturan excepciones de tipo transitionErrorException
		 System.out.println(exc.getMessage());
	}
	 /* Se comprueba si la excepcin lanzada es del tipo NullPointerException */
	catch (NullPointerException exc)
	 {//se capturan excepciones de tipo NullPointerException
		 System.out.println("No se puede realizar la transicin "+t+", al no estar activa la region a la que pertenece");
		 System.out.println("Lanzada excepcin NullPointerException");
	}
	 /* Con el siguiente catch, se debe asegurar que no se escape ninguna excepcin */
	catch (Exception exc)
	 {//se capturan el resto de Excepciones
		 System.out.println("No se puede realizar la transicin "+t);
		 System.out.println("Lanzada excepcin con mensaje:"+ exc.getMessage());
	 }
	}//Fin fireTransition 

	 // -------------------------------------

	 public void notifyEnd( ){
		 System.out.println ("		>>>> Entrada a estado FINAL => FIN DEL SIMULADOR");
		 user.notifyEnd();
	 } 

}//FIN CLASE FSM
