package StateMLplus.SMExample3.patronEstado;
public class SMExample3_FSM implements SMExample3_transitionInterface {

	 /*Se crea un objeto por cada estado*/
	 final SMExample3_ReadyState Ready;
	 final SMExample3_MovingState Moving;
	 final SMExample3_InitToolState InitTool;
	 final SMExample3_OrientedToolState OrientedTool;
	 final SMExample3_PositionToolState PositionTool;
	 final SMExample3_InitArmState InitArm;
	 final SMExample3_CalculatingPathState CalculatingPath;
	 final SMExample3_MovingArmState MovingArm;
	 final SMExample3_ErrorState Error;
	 final SMExample3_FinishedState Finished;
	 final SMExample3_EmergencyStopState EmergencyStop;
	 final SMExample3_EndState End;
	 final SMExample3_join1State join1;
	 protected SMExample3_State topRegionActual;
	 protected SMExample3_State toolRegionActual;
	 protected SMExample3_State armRegionActual;
	 protected SMExample3_State toolRegionHistory;
	 /*Se crea objeto de tipo finFSMinterface*/
	 SMExample3_finFSMinterface user;

	 /*SE CREA EL CONSTRUCTOR*/

	 public SMExample3_FSM(SMExample3_finFSMinterface userNot){

	 /*SE INICIALIZAN LOS ESTADOS*/
		 Ready = new SMExample3_ReadyState(this);
		 Moving = new SMExample3_MovingState(this);
		 InitTool = new SMExample3_InitToolState(this);
		 OrientedTool = new SMExample3_OrientedToolState(this);
		 PositionTool = new SMExample3_PositionToolState(this);
		 InitArm = new SMExample3_InitArmState(this);
		 CalculatingPath = new SMExample3_CalculatingPathState(this);
		 MovingArm = new SMExample3_MovingArmState(this);
		 Error = new SMExample3_ErrorState(this);
		 Finished = new SMExample3_FinishedState(this);
		 EmergencyStop = new SMExample3_EmergencyStopState(this);
		 End = new SMExample3_EndState(this);
		 join1 = new SMExample3_join1State(this);

	 /*Se inicializa topRegion y las regiones que tengan historicos*/
		 topRegionActual = Ready;
		 toolRegionHistory = InitTool;
	/*Se inicializa el objeto que notificar el fin de la maquina de estados*/
		 user = userNot;

	 }

	/*Se crea un tipo de datos enumerado que contendr los estados actuales de cada regin*/
	 public enum region {
		 topRegion(SMExample3_State.estado.Ready),
		 toolRegion(null),
		 armRegion(null);

		 public SMExample3_State.estado currentState;/*Variable que almacenar el estado actual*/

	 /*Se crea un constructor para inicializar la varible de estado actual, currentState*/
		 region (SMExample3_State.estado estadoIni) {
			 currentState = estadoIni;
		 }
	 }

	/*Se crea una instancia del enumerado region, para poder acceder a sus campos*/
	/*Se debe inicializarlo a cualquier valor del enumerado, da igual cual sea*/
	 region estadoActual = region.topRegion;

	 /*FUNCION QUE DEVOLVER EL ESTADO ACTUAL DE LA MQUINA DE ESTADOS.
	 DEVOLVER UN TIPO DE DATOS ENUMERADO, QUE CONTENDR EL ESTADO ACTUAL DE CADA REGIN*/
	 public region getEstadoActual (){
		 return estadoActual;
	 }

	/*FUNCION QUE SE ENCARGAR DE ACTUALIZAR EL VALOR DEL ENUMERADO QUE CONTIENE LOS ESTADOS ACTUALES*/
	 public void actualizarEstados(){
		 if(topRegionActual != null)
			 estadoActual.topRegion.currentState = topRegionActual.name;
		 else 
			 estadoActual.topRegion.currentState = null;
		 if(toolRegionActual != null)
			 estadoActual.toolRegion.currentState = toolRegionActual.name;
		 else 
			 estadoActual.toolRegion.currentState = null;
		 if(armRegionActual != null)
			 estadoActual.armRegion.currentState = armRegionActual.name;
		 else 
			 estadoActual.armRegion.currentState = null;
	 }

	 /*FUNCION QUE DEVOLVER LOS ESTADOS ACTUALES DE TODAS LAS REGIONES*/
	 public void getEstadosActualesToString(){
				 if(topRegionActual != null)
					 System.out.println(">>>>>>>>>> Region topRegion en estado:" +topRegionActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region topRegion no activa");
				 if(toolRegionActual != null)
					 System.out.println(">>>>>>>>>> Region toolRegion en estado:" +toolRegionActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region toolRegion no activa");
				 if(armRegionActual != null)
					 System.out.println(">>>>>>>>>> Region armRegion en estado:" +armRegionActual.name);
				 else
					 System.out.println(">>>>>>>>>> Region armRegion no activa");
	 }

	/*TRANSICIONES POSIBLES*/
	 public void go() throws transitionErrorException {
		 try
 		{
			 if(topRegionActual == Ready){
				 topRegionActual.go();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion go, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void contCmd() throws transitionErrorException {
		 try
 		{
			 if(topRegionActual == Ready){
				 topRegionActual.contCmd();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion contCmd, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void error() throws transitionErrorException {
		 try
 		{
			 if(topRegionActual == Moving){
				 topRegionActual.error();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion error, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void done() throws transitionErrorException {
		 try
 		{
			 if( (toolRegionActual == PositionTool) && (armRegionActual == MovingArm) ){
				 join1.done();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion done, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void abort() throws transitionErrorException {
		 try
 		{
			 if(topRegionActual == Moving){
				 topRegionActual.abort();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion abort, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void sysRecovered() throws transitionErrorException {
		 try
 		{
			 if(topRegionActual == Error){
				 topRegionActual.sysRecovered();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion sysRecovered, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void end() throws transitionErrorException {
		 try
 		{
			 if(topRegionActual == Finished){
				 topRegionActual.end();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion end, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void reStart() throws transitionErrorException {
		 try
 		{
			 if(topRegionActual == EmergencyStop){
				 topRegionActual.reStart();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion reStart, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void initialized() throws transitionErrorException {
		 try
 		{
			 if(toolRegionActual == InitTool){
				 toolRegionActual.initialized();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion initialized, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void oriented() throws transitionErrorException {
		 try
 		{
			 if(toolRegionActual == OrientedTool){
				 toolRegionActual.oriented();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion oriented, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void armInitialized() throws transitionErrorException {
		 try
 		{
			 if(armRegionActual == InitArm){
				 armRegionActual.armInitialized();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion armInitialized, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void calcDone() throws transitionErrorException {
		 try
 		{
			 if(armRegionActual == CalculatingPath){
				 armRegionActual.calcDone();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion calcDone, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }
	 public void movementDetect() throws transitionErrorException {
		 try
 		{
			 if(armRegionActual == MovingArm){
				 armRegionActual.movementDetect();
				 actualizarEstados();/*Se actualiza el enumerado que contiene los estados actuales*/
			 }
			 else {
				 System.out.println("No se puede realizar la transicion movementDetect, las regiones siguen en los estados: ");
				 getEstadosActualesToString ();
				 throw new transitionErrorException();
			 }
		 }//FIN TRY
/*se captura excepciones de tipo transitionErrorException*/
		 catch (transitionErrorException exc)
		 { 
			 System.out.println(exc.getMessage());
		 }
	 }

	/*EL SIGUIENTE METODO SE ENCARGA DE INFORMAR AL SIMULADOR DE LA ENTRADA A
	 UN ESTADO FINAL, POR LO QUE EL SIMULADOR DEBE FINALIZAR*/

	 void notifyEnd( ){
		 System.out.println ("		>>>> Entrada a estado FINAL => FIN DEL SIMULADOR");
		 user.notifyEnd();
	 } 

}
