/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package StateMLplus;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Pseudostate Kind</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see StateMLplus.StateMLplusPackage#getPseudostateKind()
 * @model
 * @generated
 */
public final class PseudostateKind extends AbstractEnumerator {
	/**
	 * The '<em><b>Join State</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Join State</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JOIN_STATE_LITERAL
	 * @model name="JoinState"
	 * @generated
	 * @ordered
	 */
	public static final int JOIN_STATE = 0;

	/**
	 * The '<em><b>Fork State</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Fork State</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FORK_STATE_LITERAL
	 * @model name="ForkState"
	 * @generated
	 * @ordered
	 */
	public static final int FORK_STATE = 1;

	/**
	 * The '<em><b>Initial State</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Initial State</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INITIAL_STATE_LITERAL
	 * @model name="InitialState"
	 * @generated
	 * @ordered
	 */
	public static final int INITIAL_STATE = 2;

	/**
	 * The '<em><b>History State</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>History State</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HISTORY_STATE_LITERAL
	 * @model name="HistoryState"
	 * @generated
	 * @ordered
	 */
	public static final int HISTORY_STATE = 3;

	/**
	 * The '<em><b>Join State</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JOIN_STATE
	 * @generated
	 * @ordered
	 */
	public static final PseudostateKind JOIN_STATE_LITERAL = new PseudostateKind(JOIN_STATE, "JoinState", "JoinState");

	/**
	 * The '<em><b>Fork State</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FORK_STATE
	 * @generated
	 * @ordered
	 */
	public static final PseudostateKind FORK_STATE_LITERAL = new PseudostateKind(FORK_STATE, "ForkState", "ForkState");

	/**
	 * The '<em><b>Initial State</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INITIAL_STATE
	 * @generated
	 * @ordered
	 */
	public static final PseudostateKind INITIAL_STATE_LITERAL = new PseudostateKind(INITIAL_STATE, "InitialState", "InitialState");

	/**
	 * The '<em><b>History State</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HISTORY_STATE
	 * @generated
	 * @ordered
	 */
	public static final PseudostateKind HISTORY_STATE_LITERAL = new PseudostateKind(HISTORY_STATE, "HistoryState", "HistoryState");

	/**
	 * An array of all the '<em><b>Pseudostate Kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final PseudostateKind[] VALUES_ARRAY =
		new PseudostateKind[] {
			JOIN_STATE_LITERAL,
			FORK_STATE_LITERAL,
			INITIAL_STATE_LITERAL,
			HISTORY_STATE_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Pseudostate Kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Pseudostate Kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static PseudostateKind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			PseudostateKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Pseudostate Kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static PseudostateKind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			PseudostateKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Pseudostate Kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static PseudostateKind get(int value) {
		switch (value) {
			case JOIN_STATE: return JOIN_STATE_LITERAL;
			case FORK_STATE: return FORK_STATE_LITERAL;
			case INITIAL_STATE: return INITIAL_STATE_LITERAL;
			case HISTORY_STATE: return HISTORY_STATE_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private PseudostateKind(int value, String name, String literal) {
		super(value, name, literal);
	}

} //PseudostateKind
